#import <objc/Object.h>
#import "../NetTalk.h"
#import <streams/streams.h>
#import <remote/NXConnection.h>

@class ClientText;

@interface TextDiff : Object <NTKPmessage>
{
	char         *channelID;
	char         *senderUName;
	char         *fromID;
	unsigned int  traceNr;

@private
	NXStream   *memStream;
	int         selStart;
	int         selEnd;
	int         selClick;
}

- init;
- initWithStream:(NXStream*)aStream;

- encodeRemotelyFor:(NXConnection *)connection 
	freeAfterEncoding:(BOOL *)flagp 
	isBycopy:(BOOL)isBycopy;
- encodeUsing:(id <NXEncoding>)portal;
- decodeUsing:(id <NXDecoding>)portal;

- (NXStream *)stream;

- getSelection:(int *)start :(int *)end;
- setSelection:(int)start :(int)end :(int)click;
- setStreamFrom:(NXStream *)aStream;

- applyTo:(ClientText *)aText;

- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

- free;

- (const char *)channelID;
- (const char *)senderUName;
- (const char *)fromID;
- (unsigned int)traceNr;

- (void)setChannel:(char *)aChannelID
	senderIs:(char *)uName from:(char *)anID
	traceNr:(unsigned int)aTraceNr;

@end
